#
# spec file for package imap
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           imap
Version:        2007e_suse
Release:        lp151.3.14
Summary:        IMAP4, POP2, and POP3 Mail Server
License:        Apache-2.0
Group:          Productivity/Networking/Email/Servers
Url:            http://www.washington.edu/imap/
Source0:        %{name}-2007e.tar.bz2
Source1:        README.SUSE
# pam config
Source2:        %{name}.pamd
Source3:        pop.pamd
# xinetd config
Source4:        %{name}.xinetd
# c-client config
Source5:        c-client.cf
Source6:        %{name}.firewall
Source100:      %{name}.rpmlintrc
Patch0:         %{name}-2001a-include.diff
Patch1:         %{name}-2004a-doc.diff
Patch2:         %{name}-2002e-ssl.diff
Patch3:         %{name}-2004-cflags.diff
Patch4:         %{name}-2001a-overflow.diff
Patch5:         %{name}-2007e-c++.patch
Patch6:         %{name}-2007e.patch
Patch7:         imap-openssl.patch
Patch8:         imap-implicit-decls.patch
Patch9:         imap-2007e-poll.patch
Patch10:        imap-2007f-format-security.patch
Patch11:        imap-openssl-1.1.patch
BuildRequires:  openssl-devel
BuildRequires:  pam-devel
Requires:       inet-daemon
Requires:       pam
BuildRequires:  fdupes

%description
This package contains IMAP4, POP2, and POP3 mail servers.

After installation, activate the servers in the file %{_sysconfdir}/inetd.conf.

%package -n libc-client2007e_suse
Summary:        IMAP4rev1/c-client Development Environment
License:        BSD-3-Clause
Group:          Development/Libraries/C and C++

%description -n libc-client2007e_suse
This package contains the libraries for IMAP client programs.

%package devel
Summary:        IMAP4rev1/c-client Development Environment
License:        BSD-3-Clause
Group:          Development/Libraries/C and C++
Provides:       libc-client-devel = %{version}
Requires:       libc-client2007e_suse = %{version}

%description devel
This package contains the libraries and header files for IMAP client
programs.

%prep
%setup -q -n %{name}-2007e
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

#K & R declarations of errno won't work anymore..
#it a no longer an integer but a macro that expands to a function  call
find -type f -name "*.[h,c]" -exec sed -i -e '/extern int errno;/d' {} +

%build
export CFLAGS="%{optflags} -DOPENSSL_NO_DEPRECATED -DOPENSSL_NO_SSL_INTERN -DDISABLE_POP_PROXY=1 -fPIC -fno-strict-aliasing -fstack-protector"
make %{?_smp_mflags} lnp MYCFLAGS="$CFLAGS" SSLTYPE=nopwd IP=6
make %{?_smp_mflags} lnp c-client
gcc $CFLAGS -shared -Wl,-soname,libc-client.so.%{version} -o libc-client.so.%{version} c-client/*.o -lpam

%install
mkdir -p %{buildroot}%{_prefix}/{sbin,share/man/man8,share/doc/packages/imap}
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
install -m 755 imapd/imapd ipopd/ipop2d ipopd/ipop3d mtest/mtest %{buildroot}%{_sbindir}/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pam.d/pop
install -m 644 -D %{SOURCE4} %{buildroot}%{_sysconfdir}/xinetd.d/%{name}
install -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/c-client.cf
install -m 644 src/imapd/imapd.8 %{buildroot}%{_mandir}/man8/imapd.8
install -m 644 src/ipopd/ipopd.8 %{buildroot}%{_mandir}/man8/ipopd.8
install -m 644 %{SOURCE1} %{buildroot}%{_docdir}/%{name}/
install -m 644 CONTENTS README docs/RELNOTES %{buildroot}%{_docdir}/%{name}/
install -m 644 docs/{FAQ,bugs,imaprc,md5,naming,drivers}.txt %{buildroot}%{_docdir}/%{name}/
mkdir -p %{buildroot}/%{_includedir}/%{name}
cp src/osdep/tops-20/*.h %{buildroot}/%{_includedir}/%{name}
cp src/osdep/unix/*.h %{buildroot}/%{_includedir}/%{name}
cp src/c-client/*.h %{buildroot}/%{_includedir}/%{name}
cp c-client/linkage.{h,c} %{buildroot}/%{_includedir}/%{name}
cp c-client/osdep.h %{buildroot}/%{_includedir}/%{name}
mkdir -p %{buildroot}/%{_libdir}
install -m 644 c-client/c-client.a %{buildroot}/%{_libdir}/libc-client.a
ln -sf libc-client.a %{buildroot}/%{_libdir}/c-client.a
install -m 755 libc-client.so.%{version} %{buildroot}/%{_libdir}/
ln -sf libc-client.so.%{version} %{buildroot}/%{_libdir}/libc-client.so
ln -sf ..%{_sbindir}/imapd %{buildroot}%{_sysconfdir}/rimapd
ln -sf ..%{_sbindir}/ipop3d %{buildroot}%{_sysconfdir}/rpop3d
ln -sf ..%{_sbindir}/ipop2d %{buildroot}%{_sysconfdir}/rpop2d
install -d %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/
install -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%{name}
%fdupes %{buildroot}%{_includedir}

%post
if [ -f %{_datadir}/ssl/certs/imapd.pem ] ; then
    if [ ! -f %{_sysconfdir}/ssl/certs/imapd.pem ] ; then
	echo "moving imapd certificate to %{_sysconfdir}/ssl/certs"
	mv %{_datadir}/ssl/certs/imapd.pem %{_sysconfdir}/ssl/certs/
    fi
fi
if [ -f %{_datadir}/ssl/certs/ipop3d.pem ] ; then
    if [ ! -f %{_sysconfdir}/ssl/certs/ipop3d.pem ] ; then
	echo "moving ipop3d certificate to %{_sysconfdir}/ssl/certs"
	mv %{_datadir}/ssl/certs/ipop3d.pem %{_sysconfdir}/ssl/certs/
    fi
fi

%post -n libc-client2007e_suse -p /sbin/ldconfig
%postun -n libc-client2007e_suse -p /sbin/ldconfig

%files
%{_sbindir}/*
%{_mandir}/man8/*
%config %{_sysconfdir}/pam.d/*
%dir %{_sysconfdir}/xinetd.d
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}
%{_sysconfdir}/rimapd
%{_sysconfdir}/rpop3d
%{_sysconfdir}/rpop2d
%doc %{_docdir}/%{name}

%files -n libc-client2007e_suse
%config(noreplace) %{_sysconfdir}/c-client.cf
%{_libdir}/*.so
%{_libdir}/*.so.*
%config %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%{name}

%files devel
%{_libdir}/*.a
%{_includedir}/%{name}

%changelog
* Mon Mar 26 2018 dimstar@opensuse.org
- Own %%{_sysconfdir}/xinetd.d: filesystem won't own this directory
  much longer (boo#1084457).
* Tue Jul  4 2017 tchvatal@suse.com
- Rename README.SuSE to README.SUSE
- Cleanup with spec-cleaner
- Add patches from RH and Debian:
  * imap-2007e-poll.patch
  * imap-2007f-format-security.patch
  * imap-openssl-1.1.patch
* Mon Mar 14 2016 crrodriguez@opensuse.org
- spec: most C sources need removal of old K&R extern int errno;
  declaration, which does not actually work with glibc where
  errno is a macro that expands to a function call.
- spec: build with -DOPENSSL_NO_DEPRECATED and
  - DOPENSSL_NO_SSL_INTERN to emulate as close as possible
  API/ABI availability of upcoming openSSL releases.
- imap-openssl.patch: remove ephemeral RSA keys support, it is
  considered insecure.openSSL 1.1 no longer supports this feature
  and package will fail to build.
- imap-openssl.patch: remove code that uses insecure tmpnam()
  function, it is not required on linux systems.
- imap-implicit-decls.patch: fix implicit fortify/pointer
  declaration rpmlint warnings.
* Sat Feb 13 2016 crrodriguez@opensuse.org
- imap-openssl.patch: Support TLS 1.2 and ECDH ciphersuites.
* Fri Dec  6 2013 mls@suse.de
- link libc-client with -lpam (as we link other packages with
  with --as-needed)
* Fri Dec 18 2009 chris@computersalat.de
- update to 2007e which
  o fix bugs
- cleanup spec
  o sort tags
  o {name} macro
- rework patches
  o imap-2002c-c++.diff > imap-2007e-c++.patch
  o imap-2006c1.diff > imap-2007e.patch
- rpmlint
  o deprecated-use-of-%%run_ldconfig
  o shlib-policy-name-error
  - renamed sub-pkg 'lib' to 'libc-client2007e_suse'
  o files-duplicate {_includedir}
  - added rpmlintrc
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Mon Jan  7 2008 mskibbe@suse.de
- Bug 351197 - several packages use wrong dir for SuSEfirewall2
  services files
* Fri Mar 16 2007 mskibbe@suse.de
- fix ports in firewall file
* Fri Mar  2 2007 mskibbe@suse.de
- imap : Support for FATE #300687: Ports for SuSEfirewall added
  via packages (#250579)
* Thu Nov 16 2006 mskibbe@suse.de
- update to version 2006c1 which
  o fix bugs
  o fix bug( Bug 217287 - imap-2004g_suse-28: use of dangerous
    "gets" function )
  o fix bug( Bug 144598 - imap-2004g_suse-4: dodgy code )
* Thu Feb  2 2006 ro@suse.de
- give libc-client.so a SONAME
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Jan 14 2006 schwab@suse.de
- Don't strip binaries.
* Wed Jan 11 2006 seife@suse.de
- add -fstack-protector
* Mon Oct 10 2005 rommel@suse.de
- version update to imap-2004g (includes fix for Bug #120608)
* Mon Aug 22 2005 rommel@suse.de
- the FreeFork license used by UW says we have to make it clear in the version
  number that we modified the sources; hinted by our license manager
* Fri Jan 21 2005 arvin@suse.de
- updated to version 2004c
* Tue Dec 14 2004 arvin@suse.de
- updated to version 2004b RC1
* Mon Nov 15 2004 kukuk@suse.de
- Use common-* PAM config files in imap.pamd and pop.pamd
* Mon Sep 13 2004 arvin@suse.de
- fixes for mailbox access over rsh and ssh (bug #43905)
* Fri Jul 16 2004 arvin@suse.de
- updated to version 2004a (bugfix release)
* Tue May 11 2004 arvin@suse.de
- updated to version 2004
- enable IPv6 support
* Fri Feb 27 2004 arvin@suse.de
- add %%run_ldconfig
* Fri Jan 16 2004 kukuk@suse.de
- Add pam-devel to neededforbuild
* Fri Oct 31 2003 arvin@suse.de
- build rpms as non-root user
* Wed Sep 24 2003 arvin@suse.de
- updated to version 2002e (minor release with primarily bugfixes)
* Thu Jun 12 2003 arvin@suse.de
- fixed directory file list
* Fri Jun  6 2003 arvin@suse.de
- updated to version 2002d (minor release with primarily bugfixes)
* Thu Apr 17 2003 arvin@suse.de
- updated to version 2002c (minor release with primarily bugfixes)
* Tue Apr 15 2003 arvin@suse.de
- explain how to create a certificate (bug #26281)
* Fri Apr 11 2003 arvin@suse.de
- added tls/ssl services to xinetd config file
* Thu Apr 10 2003 arvin@suse.de
- updated to version 2002b (maintenace release)
* Thu Apr 10 2003 arvin@suse.de
- fixed path for certificates (now /etc/ssl/certs) (bug #25762)
* Thu Mar  6 2003 arvin@suse.de
- don't use tcpwrapper config file for xinetd (bug #24773)
* Mon Mar  3 2003 arvin@suse.de
- added config file for xinetd
* Fri Feb  7 2003 kukuk@suse.de
- Use pam_unix2.so instead of pam_unix.so
- Don't use absolute path to pam modules
* Wed Nov 20 2002 arvin@suse.de
- updated to imap version 2002
- now compiled with the default SSLTYPE=nopwd in accordance with
  current IESG security requirements
* Thu Nov  7 2002 arvin@suse.de
- include linkage.c in imap-devel
* Tue Sep  3 2002 arvin@suse.de
- fixed header files to be C++ compliant
* Wed Jul 24 2002 arvin@suse.de
- moved shared library into extra sub package
* Fri Jul 12 2002 arvin@suse.de
- imap-devel package requires imap package
* Mon May  6 2002 arvin@suse.de
- fixed overflow while parsing rfc822 messages
* Mon Apr 22 2002 arvin@suse.de
- make c-client.a a link to libc-client.a
* Thu Apr 18 2002 kukuk@suse.de
- Use -fPIC instead of -fpic
* Mon Feb  4 2002 arvin@suse.de
- updated to version 2001a (maintenance release)
- turned SSL support on again
* Fri Aug 24 2001 ro@suse.de
- removed /lib/security path from pam.d config file
* Mon Jun 18 2001 arvin@suse.de
- added osdep.h to imap-devel (bug #8698)
* Tue May  8 2001 arvin@suse.de
- bzip2 sources
* Wed Apr 18 2001 arvin@suse.de
- do not explicit provide imap, it's done automatically
* Tue Feb  6 2001 arvin@suse.de
- updated to version 2000c
- fixed to compile without kernel header files
* Tue Dec 19 2000 arvin@suse.de
- ensure to link against shared version of libcrypto
* Mon Dec 18 2000 arvin@suse.de
- added SSL support
* Fri Nov  3 2000 kukuk@suse.de
- Fix compiling on SPARC
* Fri Nov  3 2000 arvin@suse.de
- changed group tag
* Thu Oct 26 2000 arvin@suse.de
- new version with imap 2000
- contains both programs and libraries
* Fri Mar 17 2000 rolf@suse.de
- removed binaries [bug#2378]
- compile -fpic for shared lib
- use RPM macros for locations of files
- set Group: tag
* Thu Dec 23 1999 rolf@suse.de
- make shared lib work and strip it
* Thu Dec  9 1999 rolf@suse.de
- new version 4.7
- build for PAM systems (LDAP not supported)
- apply lock-patch
- also build shared lib
* Fri Oct  1 1999 rolf@suse.de
- initial version 4.5.BETA
